#!use/bin/perl -w
#client端，使用的命令类似:perl socket_client.pl 192.168.0.1 4000 文件名
#第一个参数是服务器的IP地址，第二个参数是服务器监听的端口号，第三个参数是带有绝对路径的文件名
#默认每次传输1k的数据文件，如果传送的文件比较大,为了提高传输速度可能需要你调整的包容量大一些，你可以自行调整,变量名是$length，单位是字节，但注意：要改的话需要把服务器的也改了，变量名是一样的
#传送过程中的传送记录会有日志logfile_udpclient写到/tmp目录下,如果你的该目录下有这个文件，它将会追加到该文件后面，如果你不喜欢这个名字，你可以自行修改：D
use Digest::MD5;
use File::Basename;
use Socket;
$host=$ARGV[0];
$port=$ARGV[1];
$packhost=inet_aton($host);
$address=sockaddr_in($port,$packhost);
socket(CLIENT,AF_INET,SOCK_DGRAM,17);
my $filename = $ARGV[2];
my $length = 1024;
my @args = stat($filename);
my $tmp = $args[7]/$length;
if( $tmp > int($tmp) )
{
$tmp++;
}
my $package_count = int($tmp);
open LOG, ">>/tmp/logfile_udpclient";
my $realname = basename $filename;
#my $realname =~ s#.*/##;
send(CLIENT,$realname,0,$address);
recv(CLIENT,$accept_namebuff,100,0);
printf LOG "传送的文件名为:%s\n", $accept_namebuff;
open(FILE_FOR_CHECK,$filename) or die "Can't open '$filename':$!";
binmode(FILE_FOR_CHECK);
my $md5result = Digest::MD5->new->addfile(*FILE_FOR_CHECK)->hexdigest;
send(CLIENT,$md5result,0,$address);
recv(CLIENT,$accept_md5result,100,0);
printf LOG "该文件的MD5校验值为:%s\n", $accept_md5result;
close FILE_FOR_CHECK;
send(CLIENT,$package_count,0,$address);
recv(CLIENT,$accept_countbuff,100,0);
printf LOG "文件'%s'将分成%d个小包发送\n", $accept_namebuff, $accept_countbuff;
printf "文件'%s'开始发送......\n", $accept_namebuff;
open FILE_FOR_LOCAL, "$filename";
while( read(FILE_FOR_LOCAL,$piece_result,$length,0) )
{
send(CLIENT,$piece_result,0,$address);
recv(CLIENT,$recvbuff,100,0);
chop($recvbuff);
printf LOG "%s\n", $recvbuff;
}
recv(CLIENT,$message_result,150,0);
chop($message_result);
printf "%s\n", $message_result;
close LOG;
close FILE_FOR_LOCAL;
close CLIENT;
exit 1;


